#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

# global variables from the other places
use vars qw(%formData %cookieData $memberHomepage $baseCGIdir $loginHTML);

require "properties.pl";
require "$dbCGI";

#DropTables();
CreateTables();

sub DropTables{
    QueryDB("DROP TABLE user_info");
    QueryDB("DROP TABLE user_lookup");
    QueryDB("DROP TABLE item_inventory");
    QueryDB("DROP TABLE item_info");
    QueryDB("DROP TABLE item_watch");
    QueryDB("DROP TABLE course_item");
    QueryDB("DROP TABLE stat_tracking");
    QueryDB("DROP TABLE stat_summary");
    QueryDB("DROP TABLE stat_display");
}


sub CreateTables{
    # user_info - contains all the information about a user
    QueryDB("
CREATE TABLE user_info(
user_id     INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
username    VARCHAR(30) NOT NULL,
password    VARCHAR(30),
first_name  VARCHAR(30),
last_name   VARCHAR(30),
email       VARCHAR(30),
telephone   VARCHAR(30),
im_type     VARCHAR(30),
im_id       VARCHAR(30),
zipcode     VARCHAR(30),
updated     TIMESTAMP,
created     TIMESTAMP,
INDEX (user_id),
INDEX (username),
UNIQUE(username)
)
","create table user_info",$debug);

    # user_lookup - used as the fast lookup table.
    QueryDB("
CREATE TABLE user_lookup(
user_id   INTEGER UNSIGNED NOT NULL,
username  CHAR(30) NOT NULL,
password  CHAR(30) NOT NULL,
sessionkey CHAR(30) NOT NULL,
index(username,password,user_id),
index(sessionkey),
unique(user_id),
unique(username),
unique(sessionkey)
)
","create table user_lookup",$debug);

    QueryDB("
CREATE TABLE item_inventory(
item_inventory_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
user_id    INTEGER UNSIGNED NOT NULL,
item_info_id  VARCHAR(30) NOT NULL,
item_type  VARCHAR(10) NOT NULL, 
item_id    VARCHAR(30) NOT NULL, 
course     VARCHAR(30) NOT NULL, 
title      VARCHAR(250) NOT NULL,
aux_1      VARCHAR(250) NOT NULL,
aux_2      VARCHAR(250) NOT NULL,
aux_3      VARCHAR(250) NOT NULL,
aux_4      VARCHAR(250) NOT NULL,
aux_5      VARCHAR(250) NOT NULL,
aux_6      VARCHAR(250) NOT NULL,
sale_type  VARCHAR(15) NOT NULL, 
condition  VARCHAR(15),                   
ask_price  VARCHAR(10),                   
comments   VARCHAR(200),                  
updated    TIMESTAMP,
created    TIMESTAMP,
index(item_info_id),
index(course),
index(title),
index(aux_1),
index(aux_2),
index(aux_3),
index(aux_4),
index(aux_5),
index(aux_6),
index(user_id),
unique(item_inventory_id)
)
	    ","create table book inventory",$debug);


# book_info_source VARCHAR(5) NOT NULL,
# this will tell the database where the data was obtained from.
# local, central

    QueryDB("
CREATE TABLE item_info(
item_info_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
item_info_source VARCHAR(20) NOT NULL,
item_type   VARCHAR(10) NOT NULL,
item_id     VARCHAR(30) NOT NULL,
title       VARCHAR(200) NOT NULL,
aux_1       VARCHAR(200) NOT NULL,
aux_2       VARCHAR(200) NOT NULL,
aux_3       VARCHAR(200) ,
aux_4       VARCHAR(200) ,
aux_5       VARCHAR(200) ,
aux_6       VARCHAR(200),
price       VARCHAR(10),
source      VARCHAR(10),
updated     TIMESTAMP,
created     TIMESTAMP,
index(item_info_id),
index(item_id),
index(title(15)),
index(aux_1(15)),
index(aux_2(15)),
unique(item_info_id)
)
	    ","create table book info",$debug);

    QueryDB("
CREATE TABLE item_watch(
item_watch_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
user_id INTEGER UNSIGNED NOT NULL,
item_type VARCHAR(10),
search_type  VARCHAR(10),
search_term  VARCHAR(100),
created     TIMESTAMP,
index(user_id),
unique(item_watch_id)
)
	    ","create table book watch",$debug);

    QueryDB("
CREATE TABLE course_item(
course_item_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
item_info_id INTEGER UNSIGNED NOT NULL,
course VARCHAR(30) NOT NULL,
created     TIMESTAMP,
index(course_item_id),
index(item_info_id),
index(course(8))
)","",$debug);

    QueryDB("
CREATE TABLE stat_tracking (
  stat_type	ENUM(	'all_search',
                        'itemid_search',
			'aux1_search',
			'title_search',
			'course_search',
			'user_search',
			'book_added',
			'book_removed',
			'itemid_watch_added',
			'title_watch_added',
			'aux1_watch_added',
			'item_watch_removed',
			'user_added',
			'user_removed',
			'contact_sent',
			'user_login',
 	                'ad_email_sent',
                        'notify_email_sent'),
  stat_data     VARCHAR(200),
  created	timestamp
)");

    QueryDB("
CREATE TABLE stat_summary (
  stat_sum      MEDIUMTEXT,
  created	timestamp,
  index(created)
)");


QueryDB("
CREATE TABLE stat_display (
num_system_users       INTEGER UNSIGNED,
num_system_books       INTEGER UNSIGNED,
num_system_search      INTEGER UNSIGNED,
num_system_contacts    INTEGER UNSIGNED,
num_system_wanted      INTEGER UNSIGNED,
num_local_users        INTEGER UNSIGNED,
num_local_books        INTEGER UNSIGNED,
num_local_search       INTEGER UNSIGNED,
num_local_contacts     INTEGER UNSIGNED,
num_local_wanted       INTEGER UNSIGNED,
created   	       timestamp,
index (created)
)");
    

    
}





