#
# Copyright (c) 2001, eMason.com. All rights reserved.
#


######################################
# Item Info Table Manipulation
######################################

sub GetItemInfoByItemInfoId {
    my($itemInfoId) = @_;
    my($sth,$rv) = QueryDB("SELECT item_type, item_id, title, price, aux_1, aux_2, aux_3, aux_4, aux_5, aux_6 FROM item_info WHERE item_info_id = '$itemInfoId'","GetItemInfoByItemInfoId",$debug);
    my ($itemType, $itemId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6) = $sth->fetchrow_array;
    return  ($itemType, $itemId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6);
}

sub GetItemInfoIdByItemTypeItemId {
    my ($itemType, $itemId) = @_;
    my $statement = qq[SELECT item_info_id 
		       FROM item_info 
		       WHERE item_type LIKE '$itemType' 
		       AND item_id = '$itemId'];
    my ($sth,$rv) = QueryDB($statement,"",$debug);
    
    if ($rv > 0){
	($itemInfoId) = $sth->fetchrow_array;
    } else {
	# going to the CDB to get the information. However, the CDB requires a specific itemType, thus,
	# book.
	my ($status, $itemInfoId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6) = GetItemInfoFromCDB("book",$itemId);
	return $itemInfoId;
    }
    return $itemInfoId;
}


sub AddItemInfo{
    my ($itemInfoSource,$itemType,$itemId,$title,$price,$aux1,$aux2,$aux3,$aux4,$aux5,$aux6) = @_;
    
    CData($itemInfoSource,$itemType,$itemId,$title,$price,$aux1,$aux2,$aux3,$aux4,$aux5,$aux6);
    
    my $statement = qq[INSERT INTO item_info (item_info_source, item_type, item_id, title, price, aux_1, aux_2, aux_3, aux_4, aux_5, aux_6, created, updated) 
		       VALUES ('$itemInfoSource','$itemType','$itemId','$title','$price','$aux1','$aux2','$aux3','$aux4','$aux5','$aux6',NULL,NULL)];
    my ($sth,$rv) = QueryDB($statement,"",$debug);
    
    my($itemInfoId);
    if ($mySqlVer >= 3.23){
	$itemInfoId = $sth->{'insertid'};
    } else {
	($sth, $rv) = QueryDB("SELECT LAST_INSERT_ID()","",$debug);
	$itemInfoId = $sth->fetchrow;
    }

    return $itemInfoId;
}


sub GetAllItemInventory{
    my ($itemType, $start) = @_;    
    my($statement, $sth, $rv); 
    if ($start eq ""){$start = 0;}
    $statement = qq[SELECT DISTINCT II.item_info_id, II.item_type, II.item_id, II.title, II.price, II.aux_1, II.aux_2, II.aux_3, II.aux_4, II.aux_5, II.aux_6 
		    FROM item_info II, item_inventory IINV
		    WHERE II.item_type LIKE '$itemType'
		    AND II.item_info_id = IINV.item_info_id
		    ORDER BY II.title LIMIT $start, 20];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    return $sth->fetchall_arrayref;
}

sub GetItemInfoByItemTypeTitle{
    my ($itemType,$title) = @_;    
    ($sth,$rv) = QueryDB("SELECT item_info_id, item_type, item_id, title, price, aux_1, aux_2, aux_3, aux_4, aux_5, aux_6 FROM item_info WHERE item_type LIKE '$itemType' AND title LIKE '%$title%' ORDER BY title","",$debug);
    return $sth->fetchall_arrayref;
}



sub GetItemInfoByItemTypeAux1{
    my ($itemType,$aux1) = @_;
    ($sth,$rv) = QueryDB("SELECT item_info_id, item_type, item_id, title, price, aux_1, aux_2, aux_3, aux_4, aux_5, aux_6 FROM item_info WHERE item_type LIKE '$itemType' AND aux_1 LIKE '%$aux1%' ORDER BY title","",$debug);
    return $sth->fetchall_arrayref;
}
    
sub GetItemInfoByItemTypeItemId {
    # If the function fails to obtain the data from the local database, 
    # it will then go to a central database to see if there is any information there.
    # takes an item id (ex. a book ISBN #) and gets the appropriate information

    my($itemType, $itemId) = @_;

    # get data out from local database_table
    my $statement = qq[SELECT item_info_id, title, price, 
		       aux_1, aux_2, aux_3, aux_4, aux_5, aux_6
		       FROM item_info
		       WHERE item_type = '$itemType' AND item_id = '$itemId'];
    my ($sth,$rv) = QueryDB($statement,"",$debug);


    if ($rv > 0){
	my($itemInfoId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6) = $sth->fetchrow_array;
	return (1,$itemInfoId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6);
    } else {
	# get the information from the central database
	my ($status, $itemInfoId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6) = GetItemInfoFromCDB($itemType,$itemId);
	if ($status){
	    return (1,$itemInfoId, $title, $price, $aux1, $aux2, $aux3, $aux4, $aux5, $aux6);
	} else { return; }
    }
}







######################################
# Item Inventory Table Manipulation
######################################

sub GetTotalNumItemInventory{
    my ($sth,$rv) = QueryDB("SELECT count(*) FROM item_inventory");
    return $sth->fetchrow;
}

sub GetNumItemInventoryByUserId {
    my ($userId) = @_;
    my ($sth,$rv) = QueryDB("SELECT count(*) FROM item_inventory WHERE user_id = '$userId'");
    return ($sth->fetchrow);
}

sub GetItemInventoryByUserIdItemInventoryId {
    my ($userId, $itemInventoryId) = @_;

    my ($sth,$rv) = QueryDB("SELECT II.item_type, II.item_info_id, II.item_id, II.course, II.title, II.aux_1, II.aux_2, II.condition, II.ask_price, II.comments, II.updated, II.created FROM item_inventory II WHERE user_id = '$userId' AND item_inventory_id = '$itemInventoryId'","",$debug);
    
    return $sth->fetchrow_array;
}


sub UpdateItemInventoryByUserIdItemInventoryId{
    my($userId, $itemInventoryId, $title, $aux1, $aux2, $condition, $askPrice, $comments) = @_;
    my ($sth,$rv) = QueryDB("UPDATE item_inventory SET title = '$title', aux_1 = '$aux1', aux_2 = '$aux2', condition = '$condition', ask_price = '$askPrice', comments = '$comments' WHERE user_id = '$userId' AND item_inventory_id = '$itemInventoryId'","",$debug);
    return $rv;
}


sub DeleteItemInventoryByUserIdItemInventoryId{
    my($userId, $itemInventoryId) = @_;
    my($sth,$rv) = QueryDB("DELETE FROM item_inventory WHERE user_id = '$userId' AND item_inventory_id = '$itemInventoryId'","",$debug);
    # track the deletion
    AddTracking("book_removed");
    return $rv;
}


sub GetItemInventoryByItemInfoId{
    my ( $itemInfoId ) = @_;
    ($sth,$rv) = QueryDB("SELECT II.user_id, II.item_inventory_id, II.condition, II.ask_price, II.comments, UI.username FROM item_inventory II, user_info UI WHERE UI.user_id = II.user_id AND item_info_id = '$itemInfoId' ORDER BY II.ask_price, II.title ","",$debug); 
    return $sth->fetchall_arrayref;
}


sub GetItemInventoryByUserId{
    my( $userId, $start, $end ) = @_;
    if ($start ne "" && $end eq ""){
	$limitText = qq[LIMIT $start];
    }elsif ($start ne "" && $end ne ""){
	$limitText = qq[LIMIT $start, $end];
    } else {$limitText = "";}
    my ($sth,$rv) = QueryDB("SELECT item_inventory_id, item_info_id, item_type, item_id, course, title,aux_1, aux_2, ask_price, condition FROM item_inventory WHERE user_id = '$userId' ORDER BY course, item_type, title, ask_price $limitText","",$debug);
    return $sth->fetchall_arrayref;
}


sub GetItemInventoryByItemInventoryId{
    my ($itemInventoryId) = @_;
    ($sth,$rv) = QueryDB("SELECT user_id, item_info_id, title, aux_1, ask_price FROM item_inventory WHERE item_inventory_id = '$itemInventoryId' ","",$debug);
    my ($ownerId, $itemInfoId, $title, $aux1, $askPrice) = $sth->fetchrow_array;
    return ($ownerId, $itemInfoId, $title, $aux1, $askPrice);
}


sub GetItemInventoryAndUserDetailsByItemInventoryIdUsername{

    my ($itemInventoryId, $username) = @_;
    ($sth,$rv) = QueryDB("
SELECT UI.user_id, UI.first_name, UI.last_name, UI.telephone, UI.im_type, UI.im_id, UI.zipcode,
       II.item_info_id, II.title, II.aux_1, II.condition, II.comments, II.ask_price 
FROM item_inventory II, user_info UI
WHERE II.item_inventory_id = '$itemInventoryId'
AND II.user_id = UI.user_id
AND UI.username = '$username'
 ","",$debug);
    return $sth->fetchrow_array;
}



sub CheckItemInventoryIdUserIdExists{
    my($itemInventoryId, $userId) = @_;
    ($sth,$rv) = QueryDB("SELECT user_id FROM item_inventory WHERE item_inventory_id = '$itemInventoryId' AND user_id = '$userId'","",$debug);
    return $rv;
}


sub AddItemInventory{
    my ($userId, $itemInfoId, $itemType, $itemId, $course, $title, $aux1, $aux2, $condition, $askPrice, $comments) = @_;
    CData($userId, $itemInfoId, $itemType, $itemId, $course, $title, $aux1, $aux2, $condition, $askPrice, $comments);

    ($sth,$rv) = QueryDB("INSERT INTO item_inventory (user_id, item_info_id, item_type, item_id, course, title, aux_1, aux_2, condition, ask_price, comments, created) 
                          VALUES ('$userId','$itemInfoId','$itemType','$itemId', '$course','$title','$aux1','$aux2','$condition','$askPrice','$comments', NULL)
                         ","",$debug);  

    my ($itemInventoryId);
    if ($mySqlVer >= 3.23){
	$itemInventoryId = $sth->{'insertid'};
    } else {
	($sth, $rv) = QueryDB("SELECT LAST_INSERT_ID()","",$debug);
	$itemInventoryId = $sth->fetchrow;
    }

    return $itemInventoryId;
}




######################################
# Course Table Manipulation
######################################


sub GetCourseList{
    my($sth,$rv) = QueryDB("SELECT DISTINCT course FROM course_item ORDER BY course",
			   "",$debug);
    my($course_table) = $sth->fetchall_arrayref;
    return $course_table;
}


sub GetCourseListByItemInfoId{
    my($itemInfoId) = @_;
    my($sth,$rv) = QueryDB("SELECT course FROM course_item WHERE item_info_id = '$itemInfoId'","",$debug);
    return $sth->fetchall_arrayref;
}


sub GetCourseItemIdByCourseItemInfoId{
    my ($course,$itemInfoId) = @_;
    my($sth,$rv) = QueryDB("SELECT course_item_id FROM course_item 
                            WHERE course = '$course' AND item_info_id = '$itemInfoId'","",$debug);
    ($courseItemId) = $sth->fetchrow_array;
    return $courseItemId;
}


sub AddCourseItem {
    my($itemInfoId, $course) = @_;
    ($sth,$rv) = QueryDB("INSERT INTO course_item (item_info_id, course) VALUES ('$itemInfoId','$course')","",$debug);

    my ($courseItemId);
    if ($mySqlVer >= 3.23){
	$courseItemId = $sth->{'insertid'};
    } else {
	($sth, $rv) = QueryDB("SELECT LAST_INSERT_ID()","",$debug);
	$courseItemId = $sth->fetchrow;
    }

    return $courseItemId;
}



######################################
#
######################################

sub GetItemListByCourse {
    my( $course ) = @_;
    my ($sth, $rv) = QueryDB("SELECT II.item_info_id, II.item_type, II.item_id, II.title, II.price, II.aux_1, II.aux_2
                              FROM item_info II, course_item CI
                              WHERE II.item_info_id = CI.item_info_id
                              AND CI.course = '$course'
ORDER BY II.title","",$debug);
    my ($itemTable) = $sth->fetchall_arrayref;
    return $itemTable;
}


######################################
# 
######################################

sub AddItemToDB{
    my ($userId, $itemType,$itemId,$course,$title,$aux1,$aux2,$condition,$retailPrice,$askPrice,$comments) = @_;

    # Handle the item list
    # check if this is a new item. If so, add it to item_info
    ($itemInfoId) = GetItemInfoIdByItemTypeItemId($itemType,$itemId);

    if ($itemInfoId eq ""){
	# this is a new item, so add it in.
	$itemInfoId = AddItemInfo("local",$itemType,$itemId,$title,$retailPrice,$aux1,$aux2,$aux3,$aux4,$aux5,$aux6);
    }

    # Handle the course list
    # check if this is a new course + item_info_id, If so, add it to the course_item table.
    $courseItemId = GetCourseItemIdByCourseItemInfoId($course,$itemInfoId);

    # if there isn't a pre-existing similar course AND the user actually
    # entered a course
    if ($courseItemId eq "" && $course ne ""){
	# this is a new course, add it in.
	$courseItemId = AddCourseItem($itemInfoId,$course);
    }

    # Finally, add it into the user's inventory
    # add it into the item_inventory
    AddItemInventory($userId,$itemInfoId,$itemType,$itemId,$course,$title,$aux1,$aux2, $condition, $askPrice, $comments);

    # track the addition
    AddTracking("book_added",$itemId);

}



######################################
# Central Database Data Retrieval
######################################

sub GetInventoryFromCDB{

    my ($itemType, $searchType, $itemId) = @_;
    use LWP::Simple;
    
    my $data = get qq[http://www.emason.com/cgi-bin/cdb/q.cgi?q=$cdb_site_id|$cdb_username|$cdb_password|S|$itemType|$searchType|$itemId|];

    my @CDBInventory = split(/\n/,$data);
    
    ReplaceSlashN(@CDBInventory);
    # we want the total results?, it's in the last line
    ($numResults) = split(/\|/,$CDBInventory[$#CDBInventory]);
    
    return ($numResults, @CDBInventory);
    
}

sub GetItemInfoFromCDB{
    use LWP::Simple;
    my($itemType,$itemId) = @_;

    my $data = get qq[http://www.emason.com/cgi-bin/cdb/q.cgi?q=$cdb_site_id|$cdb_username|$cdb_password|i|$itemType|itemId|$itemId];

    my ($status, $itemId, $title, $price, $author, $edition, $publisher, $datePublished, $pages, $cover)=split(/\|/,$data);
    
    if ($status == 1){
	# add it into the local database
	my $itemInfoId = AddItemInfo("cdb",$itemType, $itemId, $title, $price, $author, $edition, $publisher, $datePublished, $pages, $cover);
	return($status, $itemInfoId, $title, $price, $author, $edition, $publisher, $datePublished, $pages, $cover); 
    } elsif( $status eq "Error" ) { return 0;}
    else{return 0;}
    
}

sub GetStatisticsFromCDB{
    use LWP::Simple;
    my $data = get qq[http://www.emason.com/cgi-bin/cdb/stat.cgi?q=$cdb_site_id|$cdb_username|$cdb_password];
    my ($numSystemUsers, $numSystemBooks, $numSystemSearch, $numSystemWanted, $numSystemContacts) = split(/\|/,$data);
    return($numSystemUsers, $numSystemBooks, $numSystemSearch, $numSystemWanted, $numSystemContacts);
}


sub GetNumSearchesByUserId {
    my($userId) = @_;
    my($sth, $rv) = QueryDB("SELECT COUNT(*) FROM item_watch WHERE user_id = '$userId'");
    return ($sth->fetchrow_array);

}

sub AddTracking {
    my($trackType, $trackData) = @_;
    CData($trackType, $trackData);
    my($sth,$rv) = QueryDB("INSERT INTO stat_tracking (stat_type, stat_data) VALUES ('$trackType','$trackData')","",$debug);
}

sub UpdateStatistics {
    my($statement, $sth, $rv);

    # go to the central database and get the systemwide stats.
    my ($numSystemUsers, $numSystemBooks, $numSystemSearch, $numSystemWanted, $numSystemContacts) =  GetStatisticsFromCDB();


    my ($statSummaryHash, $newStatSummaryString);
    
    #
    # Summarize the current internal stats 
    # (this allows you to delete previous stat_tracking entries)
    # 
    
    # number of users
    $statement = qq[SELECT count(*) 
		    FROM user_info];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    $numLocalUsers = $sth->fetchrow;

    # number of books
    $statement = qq[SELECT count(*) 
		    FROM item_inventory 
		    WHERE item_type = 'book'];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    $numLocalBooks = $sth->fetchrow;

    # number of wanted
    $statement = qq[SELECT count(*) 
		    FROM item_watch];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    $numLocalWanted = $sth->fetchrow;    


    
    # Summarize the data
    $statement = qq[SELECT stat_sum, created FROM stat_summary ORDER BY created DESC LIMIT 1];
    ($sth,$rv) = QueryDB($statement,"",$debug);    
    ($statSummaryString, $created) = $sth->fetchrow;
    
    # break down the data, and place into holders
    $statSummaryString =~ s/^\|//;
    $statSummaryString =~ s/\|$//;
    @statStep1 = split(/\|/,$statSummaryString);

    foreach $statStep (@statStep1){
	my($statType, $num) = split (/\:/,$statStep);
	$statSummaryHash{$statType} = $num;
    }
    
    $statement = qq[SELECT stat_type, count(*) 
		    FROM stat_tracking 
		    WHERE created > '$created'
		    GROUP BY stat_type ];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    while(@rowData = $sth->fetchrow_array){
	my($statType, $num) = @rowData;
	$statSummaryHash{$statType} += $num;
    }
    
    
    # - number of wanted in detail
    $statement = qq[SELECT search_type, count(*) 
		    FROM item_watch
		    GROUP BY search_type ];
    ($sth,$rv) = QueryDB($statement,"",$debug);

    while(@rowData = $sth->fetchrow_array){
	my($searchType, $num) = @rowData;
	$statSummaryHash{"$searchType\_watch"} = $num;
    }
    

    # count up the # of email pieces sent (unique)
    $statement = qq[SELECT sum(stat_data) FROM stat_tracking 
		    WHERE stat_type = 'ad_email_sent'
		    AND created > '$created'];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    $statSummaryHash{'ad_email_pieces_sent'} += $sth->fetchrow;

    # comes directly from the database. Not through the stat_summary
    $statSummaryHash{'num_local_users'} = $numLocalUsers;
    $statSummaryHash{'num_local_books'} = $numLocalBooks;
    $statSummaryHash{'num_local_wanted'} = $numLocalWanted;
    
   
    foreach $statType (keys %statSummaryHash){
	if ($statType ne ""){
	    $newStatSummaryString .= "|$statType:$statSummaryHash{$statType}|";
	}
    }
    
    $statement = qq[INSERT INTO stat_summary (stat_sum) VALUES ('$newStatSummaryString')];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    
    # end summarize
    

    # summarize the internal statistics for the stat_display table
    # get the previous local total & created time
    $statement = qq[SELECT num_local_search, num_local_contacts,
		    created
		    FROM stat_display
		    ORDER BY created DESC
		    LIMIT 1];
    ($sth,$rv) = QueryDB($statement,"",$debug);    
    
    my ($numLocalSearch, $numLocalContacts, $created) = $sth->fetchrow_array;    
    
    # number of searches
    $statement = qq[SELECT count(*) 
		    FROM stat_tracking 
		    WHERE 
		    (stat_type = 'itemid_search' OR
		     stat_type = 'aux1_search' OR 
		     stat_type = 'title_search' OR
		     stat_type = 'course_search' OR
		     stat_type = 'user_search' OR
		     stat_type = 'all_search')
		    AND created > '$created'
		    ];
    ($sth,$rv) = QueryDB($statement,"",$debug);    
    $numLocalSearch += $sth->fetchrow;
    
    # number of contacts's made
    $statement = qq[SELECT count(*) 
		    FROM stat_tracking 
		    WHERE 
		    stat_type LIKE 'contact_sent'
		    AND created > '$created'];
    ($sth,$rv) = QueryDB($statement,"",$debug);
    $numLocalContacts  += $sth->fetchrow;

    # update the display table.
    $statement = qq[INSERT INTO stat_display
		   (num_system_users, num_system_books, 
		    num_system_search, num_system_contacts,
		    num_system_wanted,
		    num_local_users, num_local_books,
		    num_local_search, num_local_contacts,
		    num_local_wanted) 
		   VALUES
		   ('$numSystemUsers', '$numSystemBooks', 
		    '$numSystemSearch', '$numSystemContacts',
		    '$numSystemWanted',
		    '$numLocalUsers', '$numLocalBooks',
		    '$numLocalSearch', '$numLocalContacts',
		    '$numLocalWanted')];
    ($sth,$rv) = QueryDB($statement,"",$debug);    
    
}

sub GetStatistics {
    my($statement, $sth, $rv);
    $statement = qq[SELECT 
		    num_system_users, num_system_books,
		    num_system_search, num_system_wanted,
		    num_system_contacts,
		    num_local_users, num_local_books,
		    num_local_search, num_local_wanted,
		    num_local_contacts
		    FROM stat_display
		    ORDER BY created DESC
		    LIMIT 1];
    ($sth,$rv)=QueryDB($statement,"",$debug);
    my ($numSystemUsers, $numSystemBooks,
	$numSystemSearch, $numSystemWanted, 
	$numSystemContacts,
	$numLocalUsers, $numLocalBooks, 
	$numLocalSearch, $numLocalWanted,
	$numLocalContacts) =  $sth->fetchrow_array;
    
    return ($numSystemUsers, $numSystemBooks, $numSystemSearch, 
	    $numSystemWanted, $numSystemContacts,
	    $numLocalUsers, $numLocalBooks, $numLocalSearch, 
	    $numLocalWanted, $numLocalContacts);
}

sub GetWatchStat {
    my($searchType) = @_;
    my($statement, $sth, $rv);    
    $statement = qq[SELECT count(*) from item_watch where search_type = "$searchType"];
    ($sth,$rv)=QueryDB($statement,"",$debug);
    return $sth->fetchrow;
}

sub GetSummarizedStats{
    $statement = qq[SELECT stat_sum, created FROM stat_summary 
		    ORDER BY created DESC LIMIT 1 ];
    ($sth,$rv)=QueryDB($statement,"",$debug);
    return $sth->fetchrow_array;
}

1;
