#!/usr/bin/perl 

# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

my $thisCGI="inventory.cgi";
require "utility.pl";

my $userId = CheckLogin($thisCGI);
Header("","Inventory","inventory");

&ReadFormData;	
$op = $formData{'op'};
if ($op eq "updateitem"){UpdateItem();}
elsif ($op eq "removeitem") {RemoveItem();}
elsif ($op eq "itemdetails") {ItemDetails();}
else {ShowInventory();}

Footer();

sub UpdateItem{
    $itemInventoryId = $formData{'iteminventoryid'};
    $title = $formData{'title'};
    $aux1 = $formData{'aux1'};
    $aux2 = $formData{'aux2'};
    $condition = $formData{'condition'};
    $askPrice = $formData{'askprice'};
    $comments = $formData{'comments'};

    UpdateItemInventoryByUserIdItemInventoryId($userId, $itemInventoryId, $title, $aux1, $aux2, $condition, $askPrice, $comments);
    
    ShowInventory();

}

sub RemoveItem{
    $itemInventoryId = $formData{'iteminventoryid'};
    DeleteItemInventoryByUserIdItemInventoryId($userId, $itemInventoryId);
    ShowInventory();
}


sub ItemDetails{
    $itemInventoryId = $formData{'iteminventoryid'};

    ($itemType, $itemInfoId, $itemId, $course, $title, $aux1, $aux2, $condition, $askPrice, $comments, $updated, $created) = GetItemInventoryByUserIdItemInventoryId($userId,$itemInventoryId);

	print qq[
<br>
<center>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<form method=post action="$thisCGI">
<input type=hidden name=op value="updateitem">
<input type=hidden name=iteminventoryid value="$itemInventoryId">
<tr $s_loc_bar_bgcolor><td colspan=2>&nbsp;$s_loc_bar_font_s  Inventory Detail  </td></tr>
<tr><td>
<table>
<tr>
  <td>$f_fs Title</td>
  <td><input type=text name=title value="$title" size=35></td>
</tr>
		 ];

    if ($itemType eq "book"){
	print qq[
<tr>
  <td>$f_fs Author(s)</td>
  <td><input type=text name=aux1 value="$aux1" size=35></td>
</tr>
<tr>
  <td>$f_fs Edition</td>
  <td><input type=text name=aux2 size=4 value="$aux2"></td>
 </tr>
		 ];
    } else {
	# catchall
print qq[
<tr>
  <td>$f_fs Description </td>
  <td> <textarea name=aux1 rows=10 cols=30>$aux1</textarea></td>
</tr> 
];
    }

    $conditionOptions = GetConditionOptions($condition);

    print qq[
<tr>
  <td>$f_fs Condition  </td> 
  <td> <select name=condition>$conditionOptions</select></td>
  <td> $ef$condition_error </td>
</tr>

<tr>
  <td>$f_fs Ask&nbsp;Price</td>
  <td><input type=text name=askprice size=5 value="$askPrice"></td>
  <td> $ef$price_error </td>
</tr>

<tr>
  <td>$f_fs Comments </td>
  <td> <textarea name=comments rows=5 cols=30>$comments</textarea></td>
  <td> $ef$comments_error </td>
</tr>
<tr>
  <td colspan=3><center><input type=submit value="Update details"></center></td>
</tr>
</table>


	 </td>];


    #
    # Book Information from the system
    #

    my ($itemType, $itemId, $title, $retailPrice, $author, $edition, $aux3, $aux4, $aux5, $aux6) = GetItemInfoByItemInfoId($itemInfoId);
    if (!$edition > 0){ $edition = "n/a"; }

    if ($retailPrice ne ""){
	$retailPriceText  = "<br>Retail Price: \$$retailPrice <input type=hidden name=retailprice value='$retailPrice'>";
    } else {$retailPriceText = "";}

    print qq[
<td valign=top> $f
$f <b>$title</b>
<br> by $author
<font size=1>
<br> Edition:$edition&nbsp; Pages:$aux5&nbsp; Format:$aux6&nbsp; ISBN:$itemId
<br> Date Published:$aux4&nbsp; Publisher:$aux3 &nbsp; 
</font>
$f<b> $retailPriceText </b>
	     ];
    
    #
    # Other places where the book is used
    #

    print qq[
<br><br>
Item used in these class(es): ];
    # get a list of courses where this item was used.

    $courseTable = GetCourseListByItemInfoId($itemInfoId);
    my($i);
    for $i ( 0 .. $#{$courseTable} ) {
	print qq[<br>$courseTable->[$i][0]];
    }


print qq[
</td>
</tr>
</table>
];

}


sub ShowInventory{

    my ($itemTable) = GetItemInventoryByUserId($userId);

    print qq[<br>
<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr><td colspan=3 $s_loc_bar_bgcolor>$s_loc_bar_font_s &nbsp; Current Inventory  </td></tr>
</table>
];

    if ($#{$itemTable} != -1){
	print qq[
$f

<table border=0 cellpadding=2 cellspacing=2 width=$bodyWidth>
<tr $s_header_bgcolor><td> $s_header_font_s Course</td><td> $s_header_font_s Title</td><td> $s_header_font_s Ask Price</td><td colspan=2 align=center>$s_header_font_s Options </td></tr>];
	my($i);
	for $i ( 0 .. $#{$itemTable} ) {

	    if ($i%2){$alt_bgcolor="bgcolor=#dddddd";} 
	    else {$alt_bgcolor="";}

	    $itemInventoryId= $itemTable->[$i][0];
	    print qq[<tr $alt_bgcolor>];
	    print qq[<td>$f $itemTable->[$i][4]</td>];	
	    print qq[<td>$f $itemTable->[$i][5]</td>];	
	    print qq[<td>$f \$$itemTable->[$i][8]</td>];	
	    
	    print qq[<td>$f<a href="$thisCGI?op=itemdetails&iteminventoryid=$itemInventoryId">Details</a>&nbsp;|&nbsp;<a href="$thisCGI?op=removeitem&iteminventoryid=$itemInventoryId">Remove</a></td>];
	    print qq[</tr>];
	}
	
	print qq[</table>];
    } else {
	print qq[$f <center><b>You have nothing in your inventory at the moment.</b></center>];
    }
    
    print qq[<br><center> <a href="sellitem.cgi">Add a New Book</a>];
    print qq[<br><a href="itemwatch.cgi">Add a new item watch</a>];
}
