# 
# Copyright (c) 2001 eMason.com. All rights reserved.
#

sub CheckLogin{
    my($currentLocation) = @_;

    #checks to see if there is any cookie
    GetCookieData();
    my ($sessionKey) = $cookieData{'key'};
    #print qq[Content-type: text/html \n\n $sessionKey];

    if ($sessionKey){
	# there is a session in progress
	# check to see if this is a valid session Key
	
	my($userId) = GetUserIdBySessionKey($sessionKey);
	
	if ($userId){
	    # valid session, exit from this subroutine.
	    return $userId;
	} else {
	    # invalid session, show the login form with an error message.
	    ClearCookieData();
	    ShowLoginForm("","$currentLocation","username_ind,password_ind","<li>Please re-enter your username and password.");	    
	}
	
    } else {
	# no session, the user had to login.
	ShowLoginForm("","$currentLocation","","");
    }
    
}


sub LoginUser{
    my($username, $password, $next) = @_;

    if ($username eq "") {$username = $formData{'username'};}
    if ($password eq "") {$password = $formData{'password'};}
    if ($next eq "") {$next = $formData{'next'};}

    my $errorSet;

    # basic error checks
    if ($username eq ""){ $errorSet .=  ",username_ind,"; $errorMsg .= "<li>Please enter your username.";}
    if ($password eq ""){ $errorSet .=  ",password_ind,"; $errorMsg .="<li>Please enter your password.";}

    if ($errorSet){
	ShowLoginForm($username,$next,$errorSet,$errorMsg);
	exit;
    }
    
    # check to see if the user exists.
    ($userId,$sessionKey) = GetUserIdSessionKeyByUsernamePassword($username,$password);


    if ($userId){
	# set the cookie
	ClearCookieData();

	SetCookie("key","$sessionKey",$cookiePath,$cookieExpiration);
	
	# track the login
	AddTracking("user_login",$username);

	if ($serverType eq "apache"){
	    if ($next eq ""){ print qq[Location: $default_homepage \n\n]; }
	    else { print qq[Location: $next \n\n]; }
	} else {
	    if ($next eq ""){ print qq[Content-type: text/html\n\n <html><META HTTP-EQUIV="REFRESH" CONTENT="0; URL=$default_homepage"> <center><font size=1><a href="$default_homepage">click here if you don't automatically advance</a></font></center>];}
	    else { print qq[Content-type: text/html\n\n <html> <META HTTP-EQUIV="REFRESH" CONTENT="0; URL=$next"> 
<center><font size=1><a href="$default_homepage">click here if you don't automatically advance</a></font>];}
	}

    } else {
	# user does not exist
	ClearCookieData();
	ShowLoginForm($username, $next, "username_ind,password_ind", "<li>Your username/password was not found in the system.");
	exit;
    }
    
}



sub ShowLoginForm{
    Header();
    my($username, $next, $errorSet, $errorMsg) = @_;
    my($username_ind, $password_ind);

    if ($errorSet =~ /username_ind/){$username_ind = $global_error_ind;}
    if ($errorSet =~ /password_ind/){$password_ind = $global_error_ind;}

    if ($errorMsg){$errorMsg = "$errorMsg <br><br>";}


    print qq[<center>
<br>
<table border=0 cellpadding=1 cellspacing=0 $s_loc_bar_bgcolor width=240>
<form method="post" action="login.cgi">
<input type=hidden name=op value="login">
<input type=hidden name=next value="$next">
<tr><td>
<table border=0 cellspacing=0 bgcolor=#ffffff width=100%>
  <tr>
    <td colspan=2 $s_loc_bar_bgcolor>$s_loc_bar_font_s Login $s_header_font_e</td>
  </tr>
  <tr>
    <td>$f Username$username_ind&nbsp;:$fe</td>
    <td><input type=text name=username value="$username" size=20></td>
  </tr>
  <tr>
    <td>$f Password$password_ind :$fe</td>
    <td><input type=password name=password size=20 value=""></td>
  </tr>
  <tr>
    <td colspan=2><table width=100% border=0 cellpadding=0 cellspacing=0><tr><td> $f <font size=1><a href="forgotten.cgi">Forgot your password?</a></font></td><td align=right><input valign=top type=image src="$relImgDir/login.gif" alt="login" border=0></td></tr></table>
</td>
  </tr>
</table>
</td></tr></table>
$f$errorMsg$fe
<br>$f <b>New User?</b> <a href="register.cgi">Register now!</a>
<br>

</form>
		    ];
    
    Footer();

    exit;
}

1;
